openQA Project - action #55529

job incompletes when it can not reach the openga webui host just for a single time aka. retry on 521
connect timeout in cache

2019-08-14 14:29 - okurz

Status: Resolved Start date: 2019-08-14
Priority: Low Due date:

Assignee: kraih % Done: 0%
Category: Feature requests Estimated time: 0.00 hour
Target version: Done

Difficulty:

Description

Observation

https://openga.opensuse.org/tests/1007199/file/autoinst-log.txt shows

[2019-08-14T16:26:13.0435 CEST] [debug] Download of opensuse-42.1-x86_64-Updates-20170213-1-gnome(@
64bit.gcow2 processed: [INFO] OpenQA::Worker::Cache: loading database from /var/lib/openga/cache/c

ache.sqglite

[DEBUG] CACHE: Health: Real size: 322103849472, Configured limit: 322122547200

[INFO] OpenQA::Worker::Cache: Initialized with localhost at /var/lib/openga/cache, current size is
322103849472

[INFO] Downloading opensuse-42.1-x86_64-Updates—-20170213-1-gnome@64bit.qcow2 from http://opengal-o

pensuse/tests/1007199/asset/hdd/opensuse-42.1-x86_64-Updates—20170213-1-gnome@64bit.qgcow?2

[DEBUG] CACHE: Download of /var/lib/openga/cache/opengal-opensuse/opensuse-42.1-x86_64-Updates-201
70213-1-gnome@64bit.qcow2 failed with: 521 - Connect timeout

[DEBUG] CACHE: removed /var/lib/openga/cache/opengal-opensuse/opensuse—-42.1-x86_64-Updates—-2017021
3-1-gnome@64bit.qgcow2

maybe because the worker host just restarted in before?

Suggestion

There could be some retry on "521"

Related issues:

Related to openQA Project - action #60866: Periodic stale job detection keeps... Resolved 2019-12-10
Related to openQA Project - coordination #61922: [epic] Incomplete jobs with ... Resolved 2020-02-03
Related to openQA Infrastructure - action #61844: auto_review:"download faile... Resolved 2020-01-07
Related to openQA Project - action #62459: Retry on download errors within GR... Resolved 2020-01-21
Has duplicate openQA Project - action #60167: "Download .* failed with: 521 -... Rejected 2019-11-22
History

#1 - 2019-12-10 16:57 - okurz

- Related to action #60866: Periodic stale job detection keeps scheduler busy producing a massive number of incomplete jobs (was: Again many
incomplete jobs with no logs at all) added

#2 - 2020-01-08 15:07 - mkittler
- Related to coordination #61922: [epic] Incomplete jobs with no logs at all added

#3 - 2020-01-09 21:52 - okurz

- Related to action #61844: auto_review:"download failed: 521 - Connect timeout" Network issues on openqaworker-arm-3 (and others) added

#4 - 2020-01-13 13:35 - kraih

Having worked on the cache service for the past two months, i think this is either a sporadic routing issue in the network, or the webui Apache is
overloaded at the time. The 521 is not a real HTTP status code, it's just a placeholder the cache service shows when the TCP connection could not
be established at all. The timeout for establishing the connection is 10 seconds.

2021-10-27 1/3



https://openqa.opensuse.org/tests/1007199/file/autoinst-log.txt

#5 - 2020-01-13 13:43 - kraih

- Assignee set to kraih

But agreed on the retry logic, it should probably cover this case too. | can take a look, maybe it's not that hard.

#6 - 2020-01-13 13:43 - kraih

- Status changed from New to Workable

#7 - 2020-01-16 10:42 - kraih

This PR makes the cache service retry downloads for almost every error type. https:/github.com/os-autoinst/openQA/pull/2666

#8 - 2020-01-16 13:37 - kraih

- Status changed from Workable to In Progress

#9 - 2020-01-17 10:45 - okurz

merged and deployed on 03. But we also retry on 404 now? https:/openqa.opensuse.org/tests/1146615 shows

[2020-01-17T11:12:23.0562 CET] [info] Download of GNOME_Next.x86_64-3.34.3-Buildl3.98.is0o processed:

[info] [#194488] Cache size of "/var/lib/openga/cache" is 300GiB, with limit 300GiB

[info] [#194488] Downloading "GNOME_Next.x86_64-3.34.3-Buildl13.98.iso" from "http://opengal-opensuse/tests/114
6615/asset/iso/GNOME_Next.x86_64-3.34.3-Buildl13.98.iso"

[info] [#194488] Download of "/var/lib/openga/cache/opengal-opensuse/GNOME_Next.x86_64-3.34.3-Buildl3.98.iso"
failed: 404 - Not Found

[info] [#194488] Download error 521, waiting 5 seconds for next try (4 remaining)

[info] [#194488] Downloading "GNOME_Next.x86_64-3.34.3-Buildl3.98.iso" from "http://opengal-opensuse/tests/114
6615/asset/iso/GNOME_Next .x86_64-3.34.3-Buildl3.98.iso"

[info] [#194488] Download of "/var/lib/openga/cache/opengal-opensuse/GNOME_Next.x86_64-3.34.3-Buildl3.98.iso"
failed: 404 - Not Found

[info] [#194488] Download error 521, waiting 5 seconds for next try (3 remaining)

[info] [#194488] Downloading "GNOME_Next.x86_64-3.34.3-Buildl3.98.is0o" from "http://opengal-opensuse/tests/114
6615/asset/iso/GNOME_Next .x86_64-3.34.3-Buildl13.98.iso"

[info] [#194488] Download of "/var/lib/openga/cache/opengal-opensuse/GNOME_Next.x86_64-3.34.3-Buildl3.98.is0o"
failed: 404 - Not Found

[info] [#194488] Download error 521, waiting 5 seconds for next try (2 remaining)

[info] [#194488] Downloading "GNOME_Next.x86_64-3.34.3-Buildl13.98.iso" from "http://opengal-opensuse/tests/114
6615/asset/iso/GNOME_Next.x86_64-3.34.3-Buildl13.98.iso"

[info] [#194488] Download of "/var/lib/openga/cache/opengal-opensuse/GNOME_Next.x86_64-3.34.3-Buildl3.98.iso"
failed: 404 - Not Found

[info] [#194488] Download error 521, waiting 5 seconds for next try (1 remaining)

[info] [#194488] Downloading "GNOME_Next.x86_64-3.34.3-Buildl3.98.iso" from "http://opengal-opensuse/tests/114
6615/asset/iso/GNOME_Next .x86_64-3.34.3-Buildl3.98.is0o"

[info] [#194488] Download of "/var/lib/openga/cache/opengal-opensuse/GNOME_Next.x86_64-3.34.3-Buildl3.98.iso"
failed: 404 - Not Found

[info] ([#194488] Purging "/var/lib/openga/cache/opengal-opensuse/GNOME_Next.x86_64-3.34.3-Buildl3.98.iso" beca
use of too many download errors

two observations based on questions | have received from fvogt and guillaume_g on IRC:

e There should be no retry on 404
e The error 521 is confusing when on the low level we already know it's 404

#10 - 2020-01-20 13:14 - kraih
PR opened for 4xx handling. https:/github.com/os-autoinst/openQA/pull/2675

#11 - 2020-01-21 10:58 - okurz

- Has duplicate action #60167: "Download .* failed with: 521 - Connect timeout" jobs incomplete trying to download from cache, potentially worker
specific added

#12 - 2020-01-21 12:31 - okurz
- Related to action #62459: Retry on download errors within GRU download tasks added

#13 - 2020-01-21 12:47 - okurz
- Status changed from In Progress to Resolved

- Target version set to Done
no fallout on 03. | guess we can call this "Resolved" then.

https://openga.opensuse.org/tests/1150025 is the old state showing multiple retries for 404, https://openga.opensuse.org/tests/1150570 now shows
the expected behaviour of just a single retry for 404. | did not find retries for 5xx cases now, still | think we are done. Reopen if you think differently.
